%{
#include <stdio.h>
#include <string.h>

#define YYSTYPE char*
#define YYERROR_VERBOSE

int line_no = 1;

int yyerror(const char *str)
{
	fprintf(stderr,"error in config file on line %d: %s\n", line_no, str);
	return 0;
}

int yywrap()
{
	return 1;
} 


main()
{
	//printf("setfsb configuration parser\n");
	yyparse();
} 

%}

%token INT STRING pll board cmd mode default_ fsb mem pci agp feature

%%

CONFIG:		PLL
		| PLL CONFIG
		;

PLL:		pll STRING PLL_OPTS	{ printf("PLL: \"%s\"\n", $2); }
		;

PLL_OPTS:	PLL_OPT PLL_OPTS
		| PLL_OPT;

PLL_OPT:	board STRING
		| cmd INT
		| mode MODE_OPTS OP
		| feature STRING STRING OP;

MODE_OPTS:	MODE_OPT MODE_OPTS | MODE_OPT;
MODE_OPT:	fsb '=' INT
		| mem '=' INT
		| pci '=' INT
		| agp '=' INT
		;
OPS:		OP OPS
		| OP
		;

OP:		INT '=' INT
		| INT '!' INT '=' INT
		| INT '&' INT '=' INT;

